Any given input can have three components:

   (1) real_short_name
   (2) short_name
   (3) program_version

real_short_name depends on short_name. It simply is short_name with all
instances of the '_' character removed. It is thus a dependent variable.

The three numbers above also correspond to respective @instance_variables,
so in other words we have @real_short_name, @short_name and
@program_version.

The input passed to the main class may be "unclean". The class will try
# to get the "best" result out of any given input that was supplied, no
matter how unclean this input was.

It is recommended to use this class when wanting to determine the
short_name and the program version of any given program.

Note that short_name is allowed to include '-' characters whereas
real_short_name will strip '-' characters.